package org.herac.tuxguitar.gui.keybindings;

import java.io.File;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.widgets.Composite;
import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.actions.Action;
import org.herac.tuxguitar.gui.keybindings.xml.KeyBindingReader;
import org.herac.tuxguitar.gui.keybindings.xml.KeyBindingWriter;

public class KeyBindingManager {
	private static KeyBindingManager instance;
	private Map keyBindings;
	private KeyBindingListener kbl;
	//private boolean makeDefault = false;
	
	public KeyBindingManager(){ 
		this.keyBindings = new HashMap();
		//this.keyBindings.putAll(KeyBindingReader.getKeyBindings(getSystemFileName()));
		//this.keyBindings.putAll(KeyBindingReader.getKeyBindings(getUserFileName()));
		/*
		Map userKeyBindings = KeyBindingReader.getKeyBindings(getUserFileName());
		if(userKeyBindings == null){
			userKeyBindings = KeyBindingDefaults.getDefaultKeyBindings();
			//makeDefault = true;
		}
		this.keyBindings.putAll(userKeyBindings);		
		this.kbl = new KeyBindingListener();
		*/
	}
	
	public void init(){
		Map userKeyBindings = KeyBindingReader.getKeyBindings(getUserFileName());
		if(userKeyBindings != null){
			this.keyBindings.putAll(userKeyBindings);	
		}else{
			userKeyBindings = KeyBindingDefaults.getDefaultKeyBindings();
			this.keyBindings.putAll(userKeyBindings);
			this.saveKeyBindings();
		}
				
		this.kbl = new KeyBindingListener();
	}
	
	/*
	public static KeyBindingManager instance(){
		synchronized(KeyBindingManager.class){
			if (instance == null){
				instance = new KeyBindingManager();
				//if(instance.makeDefault){
				//	instance.saveKeyBindings();
				//}
			}
		}
		
		return instance;
	}
	
	public static void init(){
		instance();
	}
	*/
    private String getSystemFileName(){
        return TuxGuitar.instance().getBasePath() + "config" + File.separator + "keybindings.xml";
    }
    
    private String getUserFileName(){
        return TuxGuitar.getUserConfigDir() + File.separator + "keybindings.xml";
    }
    
    public Action getActionForKeyBinding(KeyBinding kb){
    	return (Action)keyBindings.get(kb);
    }
    
    public void removeAction(KeyBinding kb){
    	keyBindings.remove(kb);
    }
    /*
    public void setKeyBindingForAction(KeyBinding kb,String action){
    	keyBindings.put(kb,TuxGuitar.instance().getAction(action));
    }*/
    
    public void reset(Map keyBindings){
    	this.keyBindings.clear();
    	this.keyBindings.putAll(keyBindings);
    }
    
    public Set getKeyBindings(){
    	return keyBindings.keySet();
    }
    
    public void saveKeyBindings(){
    	KeyBindingWriter.setBindings(getKeyBindings(),getUserFileName());
    }
    
    public void appendListenersTo(Composite c){
    	c.addKeyListener(kbl);
    }
    
    class KeyBindingListener implements KeyListener {

		public void keyPressed(KeyEvent evt) {
			KeyBinding kb = new KeyBinding();
			kb.setKey(evt.keyCode);
			kb.setMask(evt.stateMask);
			
			//System.out.println("Mask: "+evt.stateMask+" key: " +evt.keyCode + " char: " + evt.character);
			
			Action a = (Action)keyBindings.get(kb);			
			if (a != null){
				//System.out.println("Capturado "+kb.toString()+". Ejecutando "+a.getName()+"...");
				a.process(evt);
				
			}
		}

		public void keyReleased(KeyEvent evt) {
			
		}
    	
    }
}
